/*
 Walsh Transform Program
 148574B Kaito Tokumori
*/

package main

import (
	"fmt"
	"math"
)

func main() {
	inSignal := [][]int{
		{0, 128, 0, 128},
		{128, 0, 128, 0},
		{0, 128, 0, 128},
		{128, 0, 128, 0}}
	fmt.Println(inSignal)
	fmt.Println(wt2(inSignal))
}

func getBit(z, i int) int {
	if z < 0 || i < 0 {
		fmt.Println("getBit cannot receive a minus number!")
		return -1
	}
	if (uint16(z)>>uint16(i))%2 == 0 {
		return 0
	} else {
		return 1
	}
}

func wt2(input [][]int) [][]float64 {
	N := len(input)
	outSignal := make([][]float64, N, N)
	for s := 0; s < N; s++ {
		outSignal[s] = make([]float64, N, N)
	}
	for u := 0; u < N; u++ {
		for v, sum := 0, 0; v < N; v++ {
			for x := 0; x < N; x++ {
				for y, sign := 0, -1; y < N; y++ {
					for n, i := int(math.Log2(float64(N))), 0; i < n; i++ {
						exp := getBit(x, i)*getBit(u, n-1-i) + getBit(y, i)*getBit(v, n-1-i)
						sign *= int(math.Pow(-1, float64(exp)))
					}
					sum += sign * input[x][y]
				}
			}
			outSignal[u][v] = float64(sum / N)
		}
	}
	return outSignal
}
